SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Report'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!

!MAStringDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MATextInputComponent.! !

Object subclass: #MAColumn
	instanceVariableNames: 'report properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MAColumn subclass: #MAActionColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultTitle
	^ String new.! !

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultUseLinks
	^ true! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellContent: anObject index: aNumber on: html
	self useLinks 
		ifTrue: [ self renderCellLinkContent: anObject index: aNumber on: html ]
		ifFalse: [ self renderCellFormContent: anObject index: aNumber on: html ].! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellFormContent: anObject index: aNumber on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellLinkContent: anObject index: aNumber on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
useLinks
	^ self propertyAt: #useLinks ifAbsent: [ self defaultUseLinks ].! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
useLinks: aBoolean
	self propertyAt: #useLinks put: aBoolean.! !

MAActionColumn subclass: #MACommandColumn
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACommandColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
addCommand: aBlock text: aString
	self commands add: aBlock -> aString.! !

!MACommandColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
addCommandOn: anObject selector: aSelector text: aString
	self addCommand: (MessageSend receiver: anObject selector: aSelector) text: aString.! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
commands
	^ commands! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
commands: aCollection
	commands := aCollection! !

!MACommandColumn methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:14'!
initialize
	super initialize.
	self commands: OrderedCollection new.! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellFormContent: anObject index: aNumber on: html
	self commands
		do: [ :each |
			html
				submitButtonWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellLinkContent: anObject index: aNumber on: html
	self commands
		do: [ :each | 
			html 
				anchorWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

MAActionColumn subclass: #MASelectionColumn
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MASelectionColumn subclass: #MACheckboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultFormDeselected
	^ ScriptingSystem formAtKey: #CheckBoxOff.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultFormSelected
	^ ScriptingSystem formAtKey: #CheckBoxOn.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultSelection
	^ Set new.! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
deselect: anObject
	self selection remove: anObject ifAbsent: nil.! !

!MACheckboxColumn methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
isSelected: anObject
	^ self selection includes: anObject.! !

!MACheckboxColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellFormContent: anObject index: aNumber on: html
	html 
		checkboxWithValue: (self isSelected: anObject) 
		callback: [ :value | self select: anObject value: value ].! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
select: anObject
	self selection add: anObject.! !

MASelectionColumn subclass: #MAOptionboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:15'!
defaultFormDeselected
	^ ScriptingSystem formDictionary  formAtKey: #RadioButtonOff.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:15'!
defaultFormSelected
	^ ScriptingSystem formAtKey: #RadioButtonOn.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:15'!
defaultSelection
	^ nil! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
deselect: anObject
	self selection: nil.! !

!MAOptionboxColumn methodsFor: 'testing' stamp: 'lr 4/24/2005 10:15'!
isSelected: anObject
	^ self selection == anObject.! !

!MAOptionboxColumn methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
radioGroupFor: html
	"This is a very bad thing, you might never have seen in your own life. Very strange things might happen here, but for now it mostly does what we need."
	
	| renderer |
	renderer := self propertyAt: #radioGroupRenderer ifAbsentPut: nil.
	^ renderer == html 
		ifTrue: [ self propertyAt: #radioGroupCallback ]
		ifFalse: [
			self propertyAt: #radioGroupRenderer put: html.
			self propertyAt: #radioGroupCallback put: html radioGroup ].! !

!MAOptionboxColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderCellFormContent: anObject index: aNumber on: html
	html
		radioButtonInGroup: (self radioGroupFor: html) 
		selected: (self isSelected: anObject) 
		callback: [ self select: anObject ].! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
select: anObject
	self selection: anObject.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultFormDeselected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultFormSelected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultSelection
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
deselect: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
formDeselected
	^ self propertyAt: #formDeselected ifAbsent: [ self defaultFormDeselected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
formDeselected: aForm
	^ self propertyAt: #formDeselected put: aForm.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
formSelected
	^ self propertyAt: #formSelected ifAbsent: [ self defaultFormSelected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
formSelected: aForm
	^ self propertyAt: #formSelected put: aForm.! !

!MASelectionColumn methodsFor: 'testing' stamp: 'lr 4/24/2005 10:16'!
isSelected: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
refresh
	super refresh.
	self selection: self defaultSelection.! !

!MASelectionColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderCellLinkContent: anObject index: aNumber on: html
	| selected |
	selected := self isSelected: anObject.
	html
		anchorWithAction: [ self select: anObject value: selected not ]
		do: [ 
			html imageWithForm: (selected
				ifTrue: [ self formSelected ]
				ifFalse: [ self formDeselected ]) ].! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
select: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
select: anObject value: aBoolean
	aBoolean
		ifTrue: [ self select: anObject ]
		ifFalse: [ self deselect: anObject ].! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
selection
	selection isNil
		ifTrue: [ self selection: self defaultSelection ].
	^ selection.! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
selection: anObject
	selection := anObject! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 4/24/2005 10:17'!
descriptionComment
	^ MAStringDescription selector: #comment label: 'Comment' priority: 200.! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 4/24/2005 10:17'!
descriptionTitle
	^ MAStringDescription selector: #title label: 'Title' priority: 100.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
cascade
	^ self propertyAt: #cascade ifAbsent: [ self defaultCascade ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
cascade: anArray
	self propertyAt: #cascade put: anArray.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
column
	^ self report cache
		collect: [ :each | self valueFor: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
comment
	^ self propertyAt: #comment ifAbsent: [ self defaultComment ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultCascade
	^ #( yourself )! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultComment
	^ nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultDownArrow
	^ ScriptingSystem formAtKey: #DownArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultFooter
	^ nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultFormat
	^ MessageSend receiver: self selector: #renderCellContent:index:on:.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultSorter
	^ [ :a :b | a < b ]! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultTitle
	^ self cascade first asCapitalizedPhrase.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultUpArrow
	^ ScriptingSystem formAtKey: #UpArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultVisible
	^ true! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
footer
	^ self propertyAt: #footer ifAbsent: [ self defaultFooter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
footer: aBlock
	self propertyAt: #footer put: aBlock.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
format
	^ self propertyAt: #format ifAbsent: [ self defaultFormat ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
format: aBlock
	self propertyAt: #format put: aBlock.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
index
	^ self report columns indexOf: self.! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:14'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
isReversed
	^ self report sortReversed.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
isSortable
	^ self report sortEnabled 
		and: [ self sorter notNil ].! !

!MAColumn methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
isSorted
	^ self report sortColumn = self.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
isVisible
	^ self visible.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:14'!
properties
	^ properties! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:14'!
propertyAt: aSymbol
	^ self properties at: aSymbol.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:14'!
propertyAt: aSymbol ifAbsent: aBlock
	^ self properties at: aSymbol ifAbsent: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:14'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^ self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:14'!
propertyAt: aSymbol put: anObject
	^ self properties at: aSymbol put: anObject.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
refresh! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCell: anObject index: aNumber on: html
	html tableData: [
		self format in: [ :format |
			format numArgs caseOf: {
				[ 1 ] -> [ html render: (format value: anObject) ].
				[ 2 ] -> [ format valueWithArguments: (Array with: anObject with: html) ].
				[ 3 ] -> [ format valueWithArguments: (Array with: anObject with: aNumber with: html) ].
			} otherwise: [ self error: 'Invalid renderer block' ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellContent: anObject index: aNumber on: html
	html render: anObject.! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderFootCellOn: html
	html tableData: [ self renderFootContentOn: html ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderFootContentOn: html
	self footer isNil
		ifFalse: [ html render: self footer ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderHeadCellOn: html
	self comment isEmptyOrNil
		ifFalse: [ html attributeAt: 'title' put: self comment ].
	html tableData: [ 
		self isSortable
			ifFalse: [ self renderHeadContentOn: html ]
			ifTrue: [
				html
					anchorWithCallback: [ self report sort: self ]
					do: [ 
						self renderHeadContentOn: html.
						self renderHeadSorterOn: html ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderHeadContentOn: html
	html render: self title.! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderHeadSorterOn: html
	self isSorted ifTrue: [
		html imageWithForm: (self isReversed 
			ifTrue: [ self report sortArrowUp ]
			ifFalse: [ self report sortArrowDown ]) ].! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
report
	^ report! !

!MAColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
selector: aSymbol
	self cascade: (Array with: aSymbol).! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:14'!
setReport: aReport
	report := aReport.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result 
		sortBlock: [ :a :b | 
			[ (self valueFor: a) < (self valueFor: b) ]
				ifError: [ false ] ];
		addAll: aCollection.
	^ self isReversed
		ifFalse: [ result ]
		ifTrue: [ result reversed ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
sorter
	^ self propertyAt: #sorter ifAbsent: [ self defaultSorter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
sorter: aBlock
	self propertyAt: #sorter put: aBlock.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
title
	^ self propertyAt: #title ifAbsent: [ self defaultTitle ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
title: aString
	self propertyAt: #title put: aString.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
valueFor: aRow
	^ self cascade
		inject: aRow
		into: [ :result :each | result perform: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
visible
	^ self propertyAt: #visible ifAbsent: [ self defaultVisible ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:14'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MAColumn subclass: #MADescribedColumn
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultCascade
	self shouldNotImplement.! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultSorter
	"^ (self description comparators includes: MAComparator lessThan)
		ifTrue: [ super defaultSorter ]."
	^ super defaultSorter! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:14'!
defaultTitle
	^ self description label.! !

!MADescribedColumn methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
description
	^ description! !

!MADescribedColumn methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderCellContent: anObject index: aNumber on: html
	html render: (self description toString: anObject).! !

!MADescribedColumn methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:14'!
setDescription: aDescription
	description := aDescription! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
valueFor: aRow
	^ self description accessor read: aRow.! !

!Object methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 4/24/2005 10:14'!
asComponent
	^ self description asComponentOn: self.! !

!MAMultipleSelectionDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MAListCompositonComponent with: MACheckboxGroupComponent.! !

!MATimeStampDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MATimeStampInputComponent.! !

!MADateDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MADateInputComponent.! !

!MABinaryDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MAFileUploadComponent.! !

MAVisitor subclass: #MARenderer
	instanceVariableNames: 'html component readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

MARenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'private' stamp: 'lr 4/24/2005 10:14'!
cssClass: aString modificators: aDescription
	^ String streamContents: [ :stream |
		stream nextPutAll: aString.
		aDescription isReadonly
			ifTrue: [ stream space; nextPutAll: 'readonly' ].
		aDescription isRequired
			ifTrue: [ stream space; nextPutAll: 'required' ] ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderEditor: aDescription
	html 
		divClass: 'editor'
		with: [ super renderEditor: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderLabel: aDescription
	html 
		divClass: 'label'
		with: [ super renderLabel: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderSpacer: aDescription
	html divClass: 'spacer' with: nil.! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderViewer: aDescription
	html 
		divClass: 'viewer'
		with: [ super renderViewer: aDescription ].! !

!MACssRenderer methodsFor: 'visiting' stamp: 'lr 4/24/2005 10:14'!
visitContainer: aDescription
	html divClass: 'container' with: [ super visitContainer: aDescription ].! !

!MACssRenderer methodsFor: 'visiting' stamp: 'lr 4/24/2005 10:14'!
visitElement: aDescription
	self renderComment: aDescription.
	html 
		divClass: (self cssClass: 'element' modificators: aDescription)
		with: [ super visitElement: aDescription ].! !

!MARenderer class methodsFor: 'instance creation' stamp: 'lr 4/24/2005 10:17'!
in: aComponent on: aRenderer
	^ self new
		component: aComponent;
		html: aRenderer;
		yourself.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
component
	^ component! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
component: aComponent
	component := aComponent! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
html
	^ html! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
html: aRenderer
	html := aRenderer! !

!MARenderer methodsFor: 'initilization' stamp: 'lr 4/24/2005 10:16'!
initialize
	super initialize.
	self readonly: false.! !

!MARenderer methodsFor: 'testing' stamp: 'lr 4/24/2005 10:16'!
isReadonly
	^ self readonly.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
readonly
	^ readonly! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
readonly: aBoolean
	readonly := aBoolean! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderComment: aDescription
	aDescription hasComment
		ifTrue: [ html attributeAt: 'title' put: aDescription comment ].! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderEditor: aDescription
	aDescription autofocus
		ifFalse: [ self component renderEditorOn: html ]
		ifTrue: [
			html autofocus: [ 
				self component renderEditorOn: html ] ].! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderLabel: aDescription
	self component renderLabelOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderSpacer: aDescription! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderViewer: aDescription
	self component renderViewerOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderWidget: aDescription
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self renderViewer: aDescription ]
		ifFalse: [ self renderEditor: aDescription ].! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 4/24/2005 10:16'!
visitContainer: aDescription
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 4/24/2005 10:16'!
visitElement: aDescription
	self renderLabel: aDescription.
	self renderSpacer: aDescription.
	self renderWidget: aDescription.! !

MARenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderLabel: aDescription
	html tableHeading: [ super renderLabel: aDescription ].! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderWidget: aDescription
	html tableData: [ super renderWidget: aDescription ].! !

!MATableRenderer methodsFor: 'visiting' stamp: 'lr 4/24/2005 10:16'!
visitContainer: aDescription
	html cssClass: 'form'.
	html table: [ super renderWidget: aDescription ].! !

!MATableRenderer methodsFor: 'visiting' stamp: 'lr 4/24/2005 10:16'!
visitElement: aDescription
	self renderComment: aDescription.
	html tableRow: [ super visitElement: aDescription ].! !

!MADescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultAutofocus
	^ false! !

!MADescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClass
	^ self defaultComponentClasses first.! !

!MADescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array new.! !

!MADescription class methodsFor: '*Magritte-Seaside-description' stamp: 'lr 4/25/2005 13:23'!
descriptionComponentClass
	^ (MASingleSelectionDescription selector: #componentClass label: 'Component Class' priority: 500)
		options: self defaultComponentClasses;
		beRequired;
		yourself.! !

!MADescription methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 4/24/2005 10:15'!
asComponentOn: anObject
	^ self componentClass model: anObject description: self.! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/24/2005 10:15'!
autofocus
	^ self class defaultAutofocus.! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/24/2005 10:14'!
componentClass
	^ self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ].! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/24/2005 10:15'!
componentClass: aClass
	^ self propertyAt: #componentClass put: aClass.! !

!MAElementDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultAttributes
	^ Dictionary new.! !

!MAElementDescription class methodsFor: '*Magritte-Seaside-description' stamp: 'lr 4/24/2005 10:17'!
descriptionAutofocus
	^ MABooleanDescription selector: #autofocus label: 'Autofocus' priority: 510.! !

!MAElementDescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/24/2005 10:15'!
attributes
	^ self propertyAt: #attributes ifAbsent: [ self class defaultAttributes ].! !

!MAElementDescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/24/2005 10:15'!
attributes: aDictionary
	^ self propertyAt: #attributes put: aDictionary.! !

!MAElementDescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/24/2005 10:15'!
autofocus
	^ self propertyAt: #autofocus ifAbsent: [ self class defaultAutofocus ].! !

!MAElementDescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/24/2005 10:15'!
autofocus: aBoolean
	self propertyAt: #autofocus put: aBoolean.! !

!MATimeDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MATimeInputComponent.! !

!MABooleanDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MACheckboxComponent.! !

!MADurationDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MADurationInputComponent.! !

WADecoration subclass: #MAComponentDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponentDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
description
	^ self component description.! !

!MAComponentDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
renderer
	^ self component renderer.! !

!MAComponentDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
wrapper
	^ self component wrapper.! !

MAComponentDecoration subclass: #MAContainerDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
buttons
	self subclassResponsibility.! !

!MAContainerDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
default
	self subclassResponsibility.! !

!MAContainerDecoration methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
hasDefaultAction
	^ self default notNil.! !

!MAContainerDecoration methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
hasMultipartData
	^ self component hasMultipartData.! !

!MAContainerDecoration methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderButtonsOn: html
	self buttons do: [ :each | 
		(self hasDefaultAction and: [ self default = each ])
			ifTrue: [ html cssClass: 'default' ].
		html 
			submitButtonWithAction: (MessageSend
				receiver: self component
				selector: each key)
			text: each value ].! !

!MAContainerDecoration methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderContentOn: html
	self hasMultipartData 
		ifTrue: [ html attributeAt: 'enctype' put: 'multipart/form-data' ].
	html form: [
		self hasDefaultAction 
			ifTrue: [ self renderDefaultOn: html ].
		self renderOwnerOn: html.
		html
			divClass: 'buttons' 
			with: [ self renderButtonsOn: html ] ].! !

!MAContainerDecoration methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderDefaultOn: html
	html attributeAt: 'style' put: 'position: absolute;'.
	html 
		submitButtonWithAction: (MessageSend
			receiver: self component
			selector: self default) 
		image: html transparent1X1Form.! !

MAContainerDecoration subclass: #MAFormDecoration
	instanceVariableNames: 'buttons default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFormDecoration class methodsFor: 'instance creation' stamp: 'lr 4/24/2005 10:17'!
buttons: aCollection
	^ self new
		addButtons: aCollection;
		initializeDefault;
		yourself.! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
addButton: aSelector
	self addButton: aSelector label: (self labelForSelector: aSelector).! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
addButton: aSelector label: aString
	self buttons add: aSelector -> aString.! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
addButtons: aCollection
	aCollection do: [ :each |
		each isVariableBinding 
			ifFalse: [ self addButton: each ]
			ifTrue: [ self addButton: each key label: each value ] ].! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
buttons
	^ buttons! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
buttons: aCollection
	buttons := aCollection! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
default
	^ default! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
default: aSelector
	default := aSelector.! !

!MAFormDecoration methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:15'!
initialize
	super initialize.
	self buttons: OrderedCollection new.! !

!MAFormDecoration methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:15'!
initializeDefault
	self buttons isEmpty 
		ifFalse: [ self default: self buttons first key ].! !

MAContainerDecoration subclass: #MASwitchDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASwitchDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
buttons
	^ self isReadonly
		ifTrue: [ self buttonsView ]
		ifFalse: [ self buttonsEdit ].! !

!MASwitchDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
buttonsEdit
	^ Array with: #save -> 'Save' with: #cancel -> 'Cancel'.! !

!MASwitchDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
buttonsView
	^ Array with: #edit -> 'Edit'.! !

!MASwitchDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
default
	^ self buttons first key.! !

!MASwitchDecoration methodsFor: 'processing' stamp: 'lr 4/24/2005 10:16'!
handleAnswer: anObject continueWith: aBlock
	self component readonly: true.
	aBlock value.! !

!MASwitchDecoration methodsFor: 'testing' stamp: 'lr 4/24/2005 10:16'!
isReadonly
	^ self component isReadonly.! !

MAComponentDecoration subclass: #MAValidationDecoration
	instanceVariableNames: 'exceptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAValidationDecoration methodsFor: 'accessing-configuration' stamp: 'lr 4/24/2005 10:17'!
defaultExceptionSet
	^ MAError! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:17'!
exceptions
	^ exceptions! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:17'!
exceptions: aCollection
	exceptions := aCollection! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 4/24/2005 10:17'!
hasDebugging
	^ (self session application preferenceAt: #deploymentMode) not.! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 4/24/2005 10:17'!
hasExceptions
	^ self exceptions isEmptyOrNil not.! !

!MAValidationDecoration methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:17'!
initialize
	super initialize.
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 4/24/2005 10:17'!
processChildCallbacks: aStream
	self wrapInValidationHandlerDo: [ super processChildCallbacks: aStream ].! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderContentOn: html
	self hasExceptions
		ifTrue: [ self renderExceptionsOn: html ].
	self renderOwnerOn: html.! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderExceptionsOn: html
	html divClass: 'exceptions' with: [
		self exceptions do: [ :each |
			html 
				divClass: 'exception' 
				with: each messageText ] ].
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 4/24/2005 10:17'!
wrapInValidationHandlerDo: aBlock
	aBlock
		on: self defaultExceptionSet
		do: [ :error | 
			self exceptions: (self exceptions copyWith: error).
			error isResumable ifTrue: [ error resume ] ].! !

!MAContainer class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MAContainerComponent.! !

WAComponent subclass: #MADescriptionComponent
	instanceVariableNames: 'wrapper renderer parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MADescriptionComponent subclass: #MAContainerComponent
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:14'!
buildChildren
	^ Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (self
					buildComponent: self wrapper value
					description: each) ] ] ].! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
children
	children isNil
		ifTrue: [ self children: self buildChildren ].
	^ children.! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:14'!
children: aCollection
	children := aCollection! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
commit
	self children do: [ :each | each commit ].! !

!MAContainerComponent methodsFor: 'testing' stamp: 'lr 4/24/2005 10:14'!
hasMultipartData
	^ self children anySatisfy: [ :each | each hasMultipartData ].! !

!MAContainerComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderViewerOn: html
	self children do: [ :each | html render: each ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
reset
	self children do: [ :each | each reset ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
validate
	self children do: [ :each | each validate ].! !

!MADescriptionComponent class methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultRenderer
	^ MATableRenderer new.! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 4/24/2005 10:17'!
model: aModel
	^ self model: aModel description: aModel description.! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 4/24/2005 10:17'!
model: aModel description: aDescription
	^ self wrapper: (aModel defaultWrapperClass on: aDescription model: aModel).! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 4/25/2005 13:24'!
wrapper: aWrapper
	^ self new
		setRenderer: self defaultRenderer;
		setWrapper: aWrapper;
		yourself.! !

!MADescriptionComponent methodsFor: 'forms' stamp: 'lr 4/24/2005 10:15'!
addForm
	self addForm: #( save cancel ).! !

!MADescriptionComponent methodsFor: 'forms' stamp: 'lr 4/24/2005 10:15'!
addForm: aCollection
	self addDecoration: (MAFormDecoration buttons: aCollection).! !

!MADescriptionComponent methodsFor: 'forms' stamp: 'lr 4/24/2005 10:15'!
addSwitch
	self addDecoration: MASwitchDecoration new.
	self readonly: true.! !

!MADescriptionComponent methodsFor: 'forms' stamp: 'lr 4/24/2005 10:15'!
addValidatedForm
	self addForm; addValidation.! !

!MADescriptionComponent methodsFor: 'forms' stamp: 'lr 4/24/2005 10:15'!
addValidatedForm: aCollection
	self addForm: aCollection; addValidation.! !

!MADescriptionComponent methodsFor: 'forms' stamp: 'lr 4/24/2005 10:15'!
addValidatedSwitch
	self addSwitch; addValidation.! !

!MADescriptionComponent methodsFor: 'forms' stamp: 'lr 4/24/2005 10:15'!
addValidation
	self addDecoration: MAValidationDecoration new.! !

!MADescriptionComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildComponent: anObject
	^ self buildComponent: anObject description: anObject description.! !

!MADescriptionComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildComponent: anObject description: aDescription
	^ (aDescription asComponentOn: anObject)
		setRenderer: self renderer;
		setParent: self;
		yourself.! !

!MADescriptionComponent methodsFor: 'actions-conveniance' stamp: 'lr 4/24/2005 10:15'!
cancel
	self reset; answer: nil.! !

!MADescriptionComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
chooser: aComponent
	self chooser: aComponent titled: 'Select ' , self description label.! !

!MADescriptionComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
chooser: aComponent titled: aString
	| result |
	result := self container call: (aComponent
		addMessage: aString;
		yourself).
	result isNil
		ifFalse: [ self value: result ].! !

!MADescriptionComponent methodsFor: 'actions-conveniance' stamp: 'lr 4/24/2005 10:15'!
close
	self reset; answer: nil.! !

!MADescriptionComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
commit
	self description isReadonly
		ifFalse: [ self wrapper commit ].! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 4/24/2005 10:15'!
container
	^ self hasParentComponent
		ifTrue: [ self parent ]
		ifFalse: [ self ].! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 4/24/2005 10:15'!
description
	^ self wrapper owner.! !

!MADescriptionComponent methodsFor: 'actions-conveniance' stamp: 'lr 4/24/2005 10:15'!
edit
	self readonly: false.! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 4/24/2005 10:15'!
hasMultipartData
	^ false! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 4/24/2005 10:15'!
hasParentComponent
	^ self parent notNil.! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 4/24/2005 10:15'!
isReadonly
	^ self readonly.! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 4/24/2005 10:15'!
model
	^ self wrapper model.! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
parent
	^ parent! !

!MADescriptionComponent methodsFor: 'accessing-conveniance' stamp: 'lr 4/24/2005 10:15'!
readonly
	^ self renderer readonly.! !

!MADescriptionComponent methodsFor: 'accessing-conveniance' stamp: 'lr 4/24/2005 10:15'!
readonly: aBoolean
	self renderer readonly: aBoolean.! !

!MADescriptionComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderContentOn: html
	self renderer
		component: self;
		html: html;
		visit: self description.! !

!MADescriptionComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderEditorOn: html 
	self renderViewerOn: html.! !

!MADescriptionComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderLabelOn: html
	self description label isEmptyOrNil ifFalse: [
		html render: self description label; text: ':' ].
	self renderRequiredOn: html.! !

!MADescriptionComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderRequiredOn: html 
	(self description isRequired 
		and: [ self description isReadonly not ] 
		and: [ self renderer isReadonly not ])
			ifTrue: [ html spanClass: 'required' with: '*' ].! !

!MADescriptionComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderViewerOn: html
	self subclassResponsibility.! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
renderer
	^ renderer! !

!MADescriptionComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
reset
	self wrapper reset.! !

!MADescriptionComponent methodsFor: 'actions-conveniance' stamp: 'lr 4/24/2005 10:15'!
save
	self validate; commit; answer: self value.! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:15'!
setParent: aComponent
	parent := aComponent! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:15'!
setRenderer: aRenderer
	renderer := aRenderer! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:15'!
setWrapper: aWrapper
	wrapper := aWrapper! !

!MADescriptionComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
validate
	self wrapper validate.! !

!MADescriptionComponent methodsFor: 'accessing-wrapper' stamp: 'lr 4/24/2005 10:15'!
value
	^ self wrapper value.! !

!MADescriptionComponent methodsFor: 'accessing-wrapper' stamp: 'lr 4/24/2005 10:15'!
value: anObject
	self wrapper value: anObject.! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
wrapper
	^ wrapper! !

MADescriptionComponent subclass: #MAElementComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderEditorOn: html
	html label: [
		html attributes: self description attributes.
		html checkboxOn: #value of: self. 
		html render: self description label ].! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderViewerOn: html
	html render: (self description toString: self value).! !

MAElementComponent subclass: #MADurationInputComponent
	instanceVariableNames: 'fields days hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildDuration
	^ [ Duration days: self days hours: self hours minutes: self minutes seconds: self seconds ]
		on: Error
		do: [ :err | self wrapper errorValidation ].! !

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildField: aSelector label: aString size: anInteger
	^ (MANumberDescription selector: aSelector label: self description label , '(' , aString , ')')
		attributes: (Array with: 'size' -> anInteger with: 'maxlength' -> anInteger);
		propertyAt: #shortlabel put: aString;
		asComponentOn: self.! !

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildFields
	^ Array
		with: (self buildField: #days label: 'days' size: 3)
		with: (self buildField: #hours label: 'hours' size: 2)
		with: (self buildField: #minutes label: 'minutes' size: 2)
		with: (self buildField: #seconds label: 'seconds' size: 2).! !

!MADurationInputComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
commit
	| empty |
	self fields do: [ :each | each commit ].
	empty := self fields allSatisfy: [ :each | 
		each value isNil
			or: [ each value isString ] ].
	self value: (empty
		ifTrue: [ nil ] 
		ifFalse: [ self buildDuration ]).
	super commit.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
days
	days isNil ifTrue: [
		days := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value days ] ].
	^ days.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
days: anInteger
	days := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
fields
	fields isNil
		ifTrue: [ fields := self buildFields ].
	^ fields.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
hours
	hours isNil ifTrue: [
		hours := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value hours ] ].
	^ hours.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
hours: anInteger
	hours := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
minutes
	minutes isNil ifTrue: [
		minutes := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value minutes ] ].
	^ minutes.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
minutes: anInteger
	minutes := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderEditorOn: html
	self fields 
		do: [ :each | 
			each renderEditorOn: html.
			html render: (each description propertyAt: #shortlabel) ]
		separatedBy: [ html space: 2 ].! !

!MADurationInputComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
reset
	super reset.
	fields := days := hours := minutes := seconds := nil.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
seconds
	seconds isNil ifTrue: [
		seconds := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value seconds ] ].
	^ seconds.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/24/2005 10:15'!
seconds: anInteger
	seconds := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderViewerOn: html
	html render: self string.! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
showHalo
	^ false! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
string
	^ self description toString: self value.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
string: aString
	self value: (self description parseString: aString).! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
file
	^ file! !

!MAFileUploadComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
file: aFile
	file := aFile! !

!MAFileUploadComponent methodsFor: 'testing' stamp: 'lr 4/24/2005 10:15'!
hasMultipartData
	^ true! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
remove
	self file: nil; value: nil.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderEditorOn: html
	self value isEmptyOrNil 
		ifTrue: [ self renderUploadOn: html ]
		ifFalse: [ self renderRemoveOn: html ].! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderRemoveOn: html
	self renderViewerOn: html.
	html space; submitButtonOn: #remove of: self.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderUploadOn: html
	html attributes: self description attributes.
	html fileUploadWithCallback: [ :value | self upload: value ].
	html submitButtonOn: #upload of: self.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderViewerOn: html 
	html render: (self value ifNotNilDo: [ :value | 
		value size asFileSize ]).! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
upload
	self file notNil ifTrue: [
		self parent children do: [ :each |
			(each description propertyAt: self description key ifAbsent: nil) in: [ :kind |
				kind = #filename ifTrue: [ each wrapper value: self file fileName ].
				kind = #mimetype ifTrue: [ each wrapper value: self file contentType ] ] ] ].! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
upload: aFile
	self file: aFile.
	self value: (aFile isNil
		ifFalse: [ aFile contents asByteArray ]
		ifTrue: [ nil ]).! !

MAElementComponent subclass: #MAMultipleSelectionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAMultipleSelectionComponent subclass: #MACheckboxGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxGroupComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderEditorOn: html
	self description allOptions
		do: [ :each |
			html label: [
				html attributes: self description attributes.
				html
					checkboxWithValue: (self selectedList includes: each)
					callback: [ :value |
						value
							ifTrue: [ self add: each ]
							ifFalse: [ self remove: each ] ].
				html render: each asLabel ] ]
		separatedBy: [ html break ].! !

MAMultipleSelectionComponent subclass: #MAListCompositonComponent
	instanceVariableNames: 'availableSelected selectedSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
add
	self availableSelected isNil
		ifTrue: [ ^ self ].
	self add: self availableSelected.
	self selectedSelected: self availableSelected.
	self description isUnique
		ifTrue: [ self availableSelected: nil ].! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
availableSelected
	^ availableSelected! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
availableSelected: anObject
	availableSelected := anObject! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
moveDown
	self selectedSelected isNil 
		ifFalse: [ self selectedList moveDown: self selectedSelected ].! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
moveUp
	self selectedSelected isNil 
		ifFalse: [ self selectedList moveUp: self selectedSelected ].! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
remove
	self selectedSelected isNil
		ifTrue: [ ^ self ].
	self remove: self selectedSelected.
	self availableSelected: self selectedSelected.
	self selectedSelected: nil.! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderEditorAvailableOn: html
	html attributeAt: 'size' put: 6; attributeAt: 'style' put: 'width: 150px'.
	html attributes: self description attributes.
	html
		selectFromList: self availableList
		selected: self availableSelected
		callback: (MessageSend
			receiver: self
			selector: #availableSelected:)
		labels: [ :each | each asLabel ].! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderEditorButtonAddOn: html
	html 
		submitButtonWithAction: (MessageSend
			receiver: self 
			selector: #add)
		text: '>>'.
	html break.
	html 
		submitButtonWithAction: (MessageSend
			receiver: self 
			selector: #remove)
		text: '<<'.! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderEditorButtonOrderOn: html
	html 
		submitButtonWithAction: (MessageSend
			receiver: self 
			selector: #moveUp)
		text: 'up'.
	html break.
	html 
		submitButtonWithAction: (MessageSend
			receiver: self 
			selector: #moveDown)
		text: 'down'.! !

!MAListCompositonComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderEditorOn: html
	html layoutTable: [
		html tableRow: [
			html tableHeading: self description availableLabel.
			html tableHeading: nil.
			html tableHeading: self description selectedLabel.
			self description isOrdered
				ifTrue: [ html tableHeading: nil ] ].
		html tableRow: [
			html tableData: [ self renderEditorAvailableOn: html ].
			html tableData: [ self renderEditorButtonAddOn: html ].
			html tableData: [ self renderEditorSelectedOn: html ].
			self description isOrdered ifTrue: [ 
				html tableData: [ self renderEditorButtonOrderOn: html ] ] ] ].! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 4/24/2005 10:15'!
renderEditorSelectedOn: html
	html attributeAt: 'size' put: 6; attributeAt: 'style' put: 'width: 150px'.
	html attributes: self description attributes.
	html
		selectFromList: self selectedList
		selected: self selectedSelected
		callback: (MessageSend
			receiver: self
			selector: #selectedSelected:)
		labels: [ :each | each asLabel ].! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
selectedSelected
	^ selectedSelected! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
selectedSelected: anObject
	selectedSelected := anObject! !

!MAMultipleSelectionComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
add: anObject
	self description add: anObject to: self selectedList.! !

!MAMultipleSelectionComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
availableList
	^ self description isUnique
		ifFalse: [ self description allOptions ]
		ifTrue: [ 
			self description allOptions reject: [ :each |
				self selectedList includes: each ] ].! !

!MAMultipleSelectionComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
remove: anObject
	self description remove: anObject from: self selectedList.! !

!MAMultipleSelectionComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderViewerOn: html
	html unorderedList: [
		self selectedList do: [ :each |
			html listItem: each asLabel ] ].! !

!MAMultipleSelectionComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
selectedList
	^ self value! !

!MAMultipleSelectionComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
value
	(self description isSatisfiedBy: super value)
		ifFalse: [ self value: OrderedCollection new ].
	^ super value.! !

MAElementComponent subclass: #MASingleSelectionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MASingleSelectionComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderEditorOn: html
	html radioGroup in: [ :group |
		self description allOptions
			do: [ :each |
				html label: [
					html attributes: self description attributes.
					html 
						radioButtonInGroup: group
						selected: self value = each
						callback: [ self value: each ].
					html render: (self labelForObject: each) ] ]
			separatedBy: [ html break ] ].! !

MASingleSelectionComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		selectFromList: self description allOptions
		selected: self value
		callback: (MessageSend
			receiver: self
			selector: #value:)
		labels: (MessageSend
			receiver: self
			selector: #labelForObject:).! !

!MASingleSelectionComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
labelForObject: anObject
	^ anObject isNil
		ifTrue: [ self description nilLabel ]
		ifFalse: [ anObject asLabel ].! !

!MASingleSelectionComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderViewerOn: html
	html render: (self labelForObject: self value).! !

MAElementComponent subclass: #MATableComponent
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATableComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
buildCells
	| row column |
	^ self value collectWithIndex: [ :each :index |
		row := self description rowOfIndex: index.
		column := self description columnOfIndex: index.
		self description cellDescription copy
			accessor: MANullAccessor new;
			propertyAt: #tableIndex put: index;
			label: (String streamContents: [ :stream |
				stream nextPutAll: (self description label); nextPutAll: ' ('.
				stream nextPutAll: (self description columnLabels at: column); nextPutAll: ' / '.
				stream nextPutAll: (self description rowLabels at: row); nextPutAll: ')' ]);
			comment: (String streamContents: [ :stream |
				stream nextPutAll: (self description columnLabels at: column); nextPutAll: ' / '.
				stream nextPutAll: (self description rowLabels at: row) ]);
			asComponentOn: self ].! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 4/24/2005 10:16'!
cellAt: aRowIndex at: aColIndex
	^ self cells at: (self description indexAt: aRowIndex at: aColIndex).! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
cells
	cells isNil
		ifTrue: [ cells := self buildCells ].
	^ cells.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
commit
	self cells do: [ :each | each commit ].
	super commit.! !

!MATableComponent methodsFor: 'accessing-configuration' stamp: 'lr 4/24/2005 10:16'!
defaultValue
	^ Array new: self description cellCount.! !

!MATableComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
readUsing: aDescription
	^ self value at: (aDescription propertyAt: #tableIndex).! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderEditorOn: html
	self 
		renderTableCells: [ :cell | cell renderEditorOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderTableCells: aBlock on: html
	html table: [
		html tableRow: [
			html tableHeading: nil.
			self description columnLabels do: [ :each |
				html tableHeading: each ] ].
		self description rowLabels withIndexDo: [ :row :rindex |
			html tableRow: [
				html tableHeading: row.
				self description columnLabels withIndexDo: [ :col :cindex |
					(self cellAt: rindex at: cindex) in: [ :component |
						html attributeAt: 'title' put: component description comment.
						html tableData: [ aBlock value: component ] ] ] ] ] ].! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderViewerOn: html
	self 
		renderTableCells: [ :cell | cell renderViewerOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
reset
	super reset.
	self cells do: [ :each | each reset ].! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
validate
	self cells do: [ :each | each validate ].
	super validate.! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
value
	(self description isSatisfiedBy: super value)
		ifFalse: [ self value: self defaultValue ].
	^ super value.! !

!MATableComponent methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
write: anObject using: aDescription
	^ self value at: (aDescription propertyAt: #tableIndex) put: anObject.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textAreaOn: #value of: self.! !

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderViewerOn: html
	self value isNil ifFalse: [
		self value linesDo: [ :each |
			html 
				render: each; 
				break ] ].! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MATextInputComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:14'!
choose
	| calendar |
	calendar := WAMiniCalendar new.
	calendar
		date: ((self description isSatisfiedBy: self value)
			ifFalse: [ Date current ]
			ifTrue: [ self value ]);
		selectBlock: [ :date | calendar answer: date ];
		canSelectBlock: [ :date | true ].
	self chooser: calendar.! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:14'!
renderButtonOn: html
	html submitButtonOn: #choose of: self.! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderButtonOn: html! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderEditorOn: html
	html attributes: self description attributes.
	html textInputOn: #string of: self.
	self renderButtonOn: html.! !

MATextInputComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:17'!
current
	self value: Time current.! !

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderButtonOn: html
	html submitButtonOn: #current of: self.! !

MATextInputComponent subclass: #MATimeStampInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeStampInputComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:17'!
current
	self value: TimeStamp current.! !

!MATimeStampInputComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderButtonOn: html
	html submitButtonOn: #current of: self.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html 
		passwordInputWithValue: self string
		callback: (MessageSend 
			receiver: self 
			selector: #string:).! !

!MATextPasswordComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:17'!
string
	^ self description obfuscated: super string.! !

!MATextPasswordComponent methodsFor: 'actions' stamp: 'lr 4/24/2005 10:17'!
string: aString
	(self description isObfuscated: aString)
		ifFalse: [ super string: aString ].! !

MADescriptionComponent subclass: #MAReportComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAReportComponent methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderContentOn: html
	self description isEmptyOrNil
		ifFalse: [ self renderTableCaptionOn: html ].
	self description isEmptyOrNil
		ifFalse: [ self renderTableSummaryOn: html ].
	html tag: 'thead' do: [
		self description showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].
	html tag: 'tbody' do: [
		self description showBody 
			ifTrue: [ self renderTableBodyOn: html ] ].
	html tag: 'tfoot' do: [
		self description showFooter
			ifTrue: [ self renderTableFootOn: html ].
		self description showBatch
			ifTrue: [ self renderTableBatchOn: html ] ].! !

WAComponent subclass: #MAExampleEditor
	instanceVariableNames: 'description report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

MAExampleEditor subclass: #MADescriptionEditor
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MADescriptionEditor class methodsFor: 'examples' stamp: 'lr 4/24/2005 10:17'!
example
	^ self description: MADescribedScaffolder description.! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 4/24/2005 10:15'!
addDescription: aDescription
	| element |
	element := self call: (self 
		buildEditorFor: aDescription 
		titled: 'Add ' , aDescription description label).
	element isNil ifTrue: [ ^ self ].
	self description add: element.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildReport
	^ (MAReport rows: self description description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 4/24/2005 10:15'!
defaultDescriptionClasses
	^ OrderedCollection new
		add: MAStringDescription;
		add: MATextDescription;
		add: MASymbolDescription;
		add: MAPasswordDescription;
		add: nil;
		add: MABooleanDescription;
		add: MASingleSelectionDescription;
		add: MAMultipleSelectionDescription;
		add: nil;
		add: MANumberDescription;
		add: MADurationDescription;
		add: MADateDescription;
		add: MATimeDescription;
		add: MATimeStampDescription;
		add: nil;
		add: MATableDescription;
		add: MABinaryDescription;
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 4/24/2005 10:15'!
defaultExampleInstance
	^ MADescribedScaffolder description: self value description.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 4/24/2005 10:15'!
defaultReportInstance
	^ (MAReport rows: self value description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself.! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 4/24/2005 10:15'!
editDescription: aDescription
	self call: (self 
		buildEditorFor: aDescription 
		titled: 'Edit ' , aDescription description label).
	self report refresh.! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
example
	example isNil
		ifTrue: [ example := self defaultExampleInstance ].
	^ example.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
preview
	self call: (self example asComponent
		addValidatedForm;
		yourself).! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 4/24/2005 10:15'!
removeDescription: aDescription
	self description remove: aDescription.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderButtonsOn: html
	| selected |
	selected := ValueHolder new.
	html
		selectFromList: self defaultDescriptionClasses 
		selected: self defaultDescriptionClasses first
		callback: [ :class | selected contents: class ]
		labels: [ :class | 
			class isNil
				ifTrue: [ '--' ]
				ifFalse: [ class description label ] ].
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :class | 
				self addDescription: class new ] ]
		text: 'Add'.
	super renderButtonsOn: html.! !

!MAExampleEditor class methodsFor: 'as yet unclassified' stamp: 'lr 4/24/2005 10:17'!
description: aDescription
	^ self new
		description: aDescription;
		yourself.! !

!MAExampleEditor methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildEditorFor: anObject titled: aString
	^ anObject asComponent
		addValidatedForm;
		addMessage: aString;
		yourself.! !

!MAExampleEditor methodsFor: 'private' stamp: 'lr 4/24/2005 10:15'!
buildReport
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
cancel
	self answer: nil.! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
children
	^ Array with: self report.! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
description
	^ description! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
description: aDescription
	description := aDescription! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
edit
	self call: (self 
		buildEditorFor: description
		titled: 'Edit Container').
	self explore.! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 4/24/2005 10:15'!
moveDown: aDescription
	self description moveDown: aDescription.
	self report refresh.! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 4/24/2005 10:15'!
moveUp: aDescription
	self description moveUp: aDescription.
	self report refresh.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
preview
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderButtonsOn: html
	html submitButtonOn: #edit of: self.
	html submitButtonOn: #preview of: self.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderChildrenOn: html
	html render: self children.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:15'!
renderContentOn: html
	self renderChildrenOn: html.
	html form: [
		self renderButtonsOn: html ].! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:15'!
report
	^ report ifNil: [ report := self buildReport ].! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:15'!
save
	self answer: self description.! !

MAExampleEditor subclass: #MAReportEditor
	instanceVariableNames: 'columns visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAReportEditor class methodsFor: 'examples' stamp: 'lr 4/24/2005 10:17'!
example
	^ self description: MADescribedScaffolder example description.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
addColumn: aColumn
	self report addColumn: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
buildColumns
	^ (MAReport rows: self report columns)
		addColumn: self visible;
		addColumnDescription: MAColumn descriptionTitle;
		addColumnDescription: MAColumn descriptionComment;
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #remove: text: 'remove';
			yourself);
		yourself.! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
buildVisible
	^ MACheckboxColumn new
		title: 'V';
		comment: 'Visibility';
		selection: (self report columns 
			select: [ :each | each isVisible ])
			asSet;
		yourself.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
children
	^ Array with: self columns.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
columns
	columns isNil
		ifTrue: [ columns := self buildColumns ].
	^ columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
preview	
	self report
		decorateWith: (WAWindowDecoration new
			title: self report tableCaption;
			yourself)
		during: [ self call: self report ].! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
refresh
	self columns rows: self report columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
remove: aColumn
	self report remove: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderAddOn: html
	| selected |
	selected := ValueHolder new.
	"html
		selectFromList: self columns selected: nil
		callback: [ :value | selected contents: value ]
		labels: [ :value | value title ]."
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :value | 
				self addColumn: value copy ] ]
		text: 'add'.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
report
	^ report! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
save
	 self answer: self report.! !

!MAReportEditor methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:16'!
setReport: aReport
	report := aReport copy.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
visible
	visible isNil
		ifTrue: [ visible := self buildVisible ].
	^ visible.! !

WAComponent subclass: #MAReport
	instanceVariableNames: 'rows cache columns properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2000
	^ MABooleanDescription selector: #showHeader label: 'Show Header' priority: 2000.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2100
	^ MABooleanDescription selector: #showBody label: 'Show Body' priority: 2100.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2200
	^ MAStringDescription selector: #tableEmpty label: 'Empty' priority: 2200.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2300
	^ MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2400
	^ MABooleanDescription selector: #showCaption label: 'Show Caption' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2500
	^ MAStringDescription selector: #tableCaption label: 'Caption' priority: 2500.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2600
	^ MABooleanDescription selector: #showSummary label: 'Show Summary' priority: 2600.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/24/2005 10:17'!
description2700
	^ MAStringDescription selector: #tableSummary label: 'Summary' priority: 2700.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/24/2005 10:17'!
description4000
	^ MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 4000.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/24/2005 10:17'!
description4100
	^ MANumberDescription selector: #batchSize label: 'Size' priority: 4100.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/24/2005 10:17'!
description4200
	^ MABooleanDescription selector: #showBatchFirstLast label: 'Show First/Last' priority: 4200.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/24/2005 10:17'!
description4300
	^ MABooleanDescription selector: #showBatchPreviousNext label: 'Show Previous/Next' priority: 4300.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/24/2005 10:17'!
description4400
	^ MABooleanDescription selector: #showBatchPages label: 'Show Pages' priority: 4400.! !

!MAReport class methodsFor: 'examples' stamp: 'lr 4/24/2005 10:17'!
example
	^ (MAReport rows: (0 to: 255))
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the decimal number';
			title: 'Dec');
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the binary number';
			title: 'Bin';
			format: [ :value | (value printStringBase: 2) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the octal number';
			title: 'Oct';
			format: [ :value | (value printStringBase: 8) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the hexadecimal number';
			title: 'Hex';
			format: [ :value | (value printStringBase: 16) allButFirst: 3 ];
			yourself);
		addColumn: (MAColumn new
			selector: #sin;
			comment: 'the sinus';
			title: 'Sinus');
		addColumn: (MAColumn new
			selector: #cos;
			comment: 'the cosinus';
			title: 'Cosinus');
		addColumn: (MAColumn new
			selector: #ln;
			comment: 'the natural logarithm';
			title: 'Logarithm');
		addColumn: (MAColumn new
			selector: #exp;
			comment: 'the exponential';
			title: 'Exponential');
		yourself.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 4/24/2005 10:17'!
rows: aCollection
	^ self new
		rows: aCollection;
		yourself.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 4/24/2005 10:17'!
rows: aCollection description: aDescription
	| report |
	report := self rows: aCollection.
	aDescription asContainer do: [ :each |
		report addColumnDescription: each ].
	^ report.! !

!MAReport methodsFor: 'README' stamp: 'lr 4/24/2005 10:16'!
NOW
	" do not use ... this is unfinished, buggy and not working "! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/24/2005 10:16'!
addColumn: aColumn
	columns := columns copyWith: aColumn.
	^ aColumn setReport: self; yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/24/2005 10:16'!
addColumnCascade: anArray
	^ (self addColumn: MAColumn new)
		cascade: anArray;
		yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/24/2005 10:16'!
addColumnDescription: aDescription
	^ self addColumn: (MADescribedColumn new
		setDescription: aDescription;
		yourself).! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/24/2005 10:16'!
addColumnSelector: aSelector
	^ (self addColumn: MAColumn new)
		selector: aSelector;
		yourself.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
backtrackedAt: aSymbol
	^ (self propertyAt: aSymbol)
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
backtrackedAt: aSymbol ifAbsent: aBlock
	^ (self propertyAt: aSymbol ifAbsent: [ ^ aBlock value ])
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
backtrackedAt: aSymbol ifAbsentPut: aBlock
	^ self 
		backtrackedAt: aSymbol 
		ifAbsent: [ self backtrackedAt: aSymbol put: aBlock value ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
backtrackedAt: aSymbol put: anObject
	(self propertyAt: aSymbol ifAbsentPut: [ WAStateHolder new ])
		contents: anObject.
	^ anObject.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
batchEndIndex
	^ self batchPage * self batchSize min: self cache size.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
batchMaxPages
	^ (self cache size / self batchSize) 
		ceiling.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
batchPage
	^ self backtrackedAt: #batchPage ifAbsentPut: [ self defaultBatchPage ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
batchPage: anInteger
	self backtrackedAt: #batchPage put: anInteger.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
batchPageRange
	^ self batchPageRangeStart to: self batchPageRangeEnd.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
batchPageRangeEnd
	^ self batchMaxPages min: self batchPage + 9.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
batchPageRangeStart
	^ self defaultBatchPage max: self batchPage - 9.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
batchSize
	^ self propertyAt: #batchSize ifAbsentPut: [ self defaultBatchSize ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
batchSize: anInteger
	self propertyAt: #batchSize put: anInteger.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
batchStartIndex
	^ (self batchPage - 1) * self batchSize + 1.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
cache
	"Return the cached rows of the receiver, these rows are filtered and sorted."

	cache isNil ifTrue: [ 
		self cache: (self 
			sortRows: (self 
				filterRows: self 
					rows)) ].
	^ cache.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
cache: aCollection
	cache := aCollection! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 4/24/2005 10:16'!
columns
	^ columns! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultBatchPage
	^ 1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultBatchSize
	^ 10! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultRowFilter
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultRowPeriod
	^ 1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultRowStyles
	^ Array with: 'odd' with: 'even'.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowBatch
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowBatchFirstLast
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowBatchPages
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowBatchPreviousNext
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowBody
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowCaption
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowFooter
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowHeader
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultShowSummary
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultSortArrowDown
	^ ScriptingSystem formAtKey: #DownArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultSortArrowUp
	^ ScriptingSystem formAtKey: #UpArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultSortColumn
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultSortEnabled
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultSortReversed
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultTableCaption
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultTableEmpty
	^ 'The report is empty.'! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/24/2005 10:16'!
defaultTableSummary
	^ nil! !

!MAReport methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
filterRows: aCollection
	^ self hasRowFilter
		ifFalse: [ aCollection ]
		ifTrue: [ aCollection select: self rowFilter ].! !

!MAReport methodsFor: 'testing' stamp: 'lr 4/24/2005 10:16'!
hasRowFilter
	^ self rowFilter notNil.! !

!MAReport methodsFor: 'initialization' stamp: 'lr 4/24/2005 10:16'!
initialize
	super initialize.
	rows := columns := Array new.
	properties := Dictionary new.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
isOnFirstPage
	^ self batchPage = 1.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 4/24/2005 10:16'!
isOnLastPage
	^ self batchPage = self batchMaxPages.! !

!MAReport methodsFor: 'testing' stamp: 'lr 4/24/2005 10:16'!
isSorted
	^ self sortColumn notNil.! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/24/2005 10:16'!
moveDown: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/24/2005 10:16'!
moveUp: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!MAReport methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
nextPage
	self isOnLastPage 
		ifFalse: [ self batchPage: self batchPage + 1 ].! !

!MAReport methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
previousPage
	self isOnFirstPage 
		ifFalse: [ self batchPage: self batchPage - 1 ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
properties
	^ properties! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
propertyAt: aSymbol
	^ self properties at: aSymbol! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
propertyAt: aSymbol ifAbsent: aBlock
	^ self properties at: aSymbol ifAbsent: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^ self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 4/24/2005 10:16'!
propertyAt: aSymbol put: anObject
	^ self properties at: aSymbol put: anObject.! !

!MAReport methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
refresh
	self cache: nil; batchPage: self defaultBatchPage.
	self columns do: [ :each | each refresh ].! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/24/2005 10:16'!
remove: aColumn
	columns := columns copyWithout: aColumn.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 4/24/2005 10:16'!
renderBatchFirstOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self defaultBatchPage ] text: '|<' ]
		ifTrue: [ html text: '|<' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 4/24/2005 10:16'!
renderBatchItemsOn: html
	self batchPageRangeStart > self defaultBatchPage
		ifTrue: [ html text: '...'; space ].
	self batchPageRange do: [ :index |
		self batchPage = index
			ifFalse: [ html anchorWithAction: [ self batchPage: index ] text: index ]
			ifTrue: [ html spanClass: 'current' with: index ].
		html space ].
	self batchPageRangeEnd < self batchMaxPages 
		ifTrue: [ html text: '...'; space ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 4/24/2005 10:16'!
renderBatchLastOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self batchMaxPages ] text: '>|' ]
		ifTrue: [ html text: '>|' ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 4/24/2005 10:16'!
renderBatchNextOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 4/24/2005 10:16'!
renderBatchPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!MAReport methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderContentOn: html
	html cssClass: 'report'; table: [ self renderTableOn: html ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/24/2005 10:16'!
renderTableBatchOn: html
	self batchSize < self cache size ifTrue: [
		html tableRow: [
			html cssClass: 'batch'; attributeAt: 'colspan' put: self columns size.
			html tableData: [
				self showBatchFirstLast
					ifTrue: [ self renderBatchFirstOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchPreviousOn: html ].
				self showBatchPages
					ifTrue: [ self renderBatchItemsOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchNextOn: html ].
				self showBatchFirstLast
					ifTrue: [ self renderBatchLastOn: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/24/2005 10:16'!
renderTableBodyOn: html
	self visible isEmpty 
		ifTrue: [
			html cssClass: 'empty'.
			html tableRow: [
				html attributeAt: #colspan put: self columns size.
				html tableData: [
					html render: self tableEmpty ] ] ]
		ifFalse: [
			self visible withIndexDo: [ :row :index |
				html cssClass: (self rowStyleForNumber: index).
				html tableRow: [
					self columns do: [ :col |
						col 
							renderCell: (col valueFor: row) 
							index: index on: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/24/2005 10:16'!
renderTableCaptionOn: html
	html tag: 'caption' do: self tableCaption.! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/24/2005 10:16'!
renderTableFootOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderFootCellOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/24/2005 10:16'!
renderTableHeadOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderHeadCellOn: html ] ].! !

!MAReport methodsFor: 'rendering' stamp: 'lr 4/24/2005 10:16'!
renderTableOn: html
	self showCaption
		ifTrue: [ self renderTableCaptionOn: html ].
	self showSummary
		ifTrue: [ self renderTableSummaryOn: html ].
	html tag: 'thead' do: [
		self showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].
	html tag: 'tbody' do: [
		self showBody 
			ifTrue: [ self renderTableBodyOn: html ] ].
	html tag: 'tfoot' do: [
		self showFooter
			ifTrue: [ self renderTableFootOn: html ].
		self showBatch
			ifTrue: [ self renderTableBatchOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/24/2005 10:16'!
renderTableSummaryOn: html
	html tag: 'summary' do: self tableSummary.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
rowFilter
	^ self backtrackedAt: #rowFilter ifAbsentPut: [ self defaultRowFilter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
rowFilter: aBlock
	self backtrackedAt: #rowFilter put: aBlock.
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
rowPeriod
	^ self propertyAt: #rowPeriod ifAbsentPut: [ self defaultRowPeriod ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
rowPeriod: aNumber
	self propertyAt: #rowPeriod put: aNumber.! !

!MAReport methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
rowStyleForNumber: aNumber
	^ self rowStyles 
		at: ((aNumber - 1 // self rowPeriod) \\ self rowStyles size) + 1
		ifAbsent: [ String new ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
rowStyles
	^ self propertyAt: #rowStyles ifAbsentPut: [ self defaultRowStyles ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
rowStyles: aCollection
	self propertyAt: #rowStyles put: aCollection.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
rows
	"Return the rows of the receiver."

	^ rows ifNil: [ self rows: Array new ].! !

!MAReport methodsFor: 'accessing' stamp: 'lr 4/24/2005 10:16'!
rows: aCollection
	"Set the rows of the receiver."
	
	rows = aCollection 
		ifTrue: [ ^ self ].
	rows := aCollection.
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatch
	^ self propertyAt: #showBatch ifAbsentPut: [ self defaultShowBatch ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatchFirstLast
	^ self propertyAt: #showBatchFirstLast ifAbsentPut: [ self defaultShowBatchFirstLast ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatchFirstLast: aBoolean
	self propertyAt: #showBatchFirstLast put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatchPages
	^ self propertyAt: #showBatchPages ifAbsentPut: [ self defaultShowBatchPages ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatchPages: aBoolean
	self propertyAt: #showBatchPages put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatchPreviousNext
	^ self propertyAt: #showBatchPreviousNext ifAbsentPut: [ self defaultShowBatchPreviousNext ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBatchPreviousNext: aBoolean
	self propertyAt: #showBatchPreviousNext put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBody
	^ self propertyAt: #showBody ifAbsentPut: [ self defaultShowBody ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showBody: aBoolean
	self propertyAt: #showBody put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showCaption
	^ self propertyAt: #showCaption ifAbsentPut: [ self defaultShowCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showCaption: aBoolean
	self propertyAt: #showCaption put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showFooter
	^ self propertyAt: #showFooter ifAbsentPut: [ self defaultShowFooter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showHeader
	^ self propertyAt: #showHeader ifAbsentPut: [ self defaultShowHeader ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showSummary
	^ self propertyAt: #showSummary ifAbsentPut: [ self defaultShowSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
showSummary: aBoolean
	self propertyAt: #showSummary put: aBoolean.! !

!MAReport methodsFor: 'actions' stamp: 'lr 4/24/2005 10:16'!
sort: aColumn
	aColumn = self sortColumn
		ifTrue: [
			self sortReversed
				ifFalse: [ self sortReversed: true ]
				ifTrue: [ self sortColumn: nil; sortReversed: false ] ]
		ifFalse: [ self sortColumn: aColumn; sortReversed: false ].
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortArrowDown
	^ self propertyAt: #sortArrowDown ifAbsentPut: [ self defaultSortArrowDown ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortArrowDown: aForm
	self propertyAt: #sortArrowDown put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortArrowUp
	^ self propertyAt: #sortArrowUp ifAbsentPut: [ self defaultSortArrowUp ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortArrowUp: aForm
	self propertyAt: #sortArrowUp put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortColumn
	^ self backtrackedAt: #sortColumn ifAbsentPut: [ self defaultSortColumn ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortColumn: aColumn
	self backtrackedAt: #sortColumn put: aColumn.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortEnabled
	^ self propertyAt: #sortEnabled ifAbsentPut: [ self defaultSortEnabled ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortEnabled: aBoolean
	self propertyAt: #sortEnabled put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortReversed
	^ self backtrackedAt: #sortReversed ifAbsentPut: [ self defaultSortReversed ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
sortReversed: aBoolean
	self backtrackedAt: #sortReversed put: aBoolean.! !

!MAReport methodsFor: 'private' stamp: 'lr 4/24/2005 10:16'!
sortRows: aCollection
	^ self isSorted
		ifFalse: [ aCollection ]
		ifTrue: [ self sortColumn sortRows: aCollection ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
tableCaption
	^ self propertyAt: #tableCaption ifAbsentPut: [ self defaultTableCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
tableCaption: aString
	self propertyAt: #tableCaption put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
tableEmpty
	^ self propertyAt: #tableEmpty ifAbsentPut: [ self defaultTableEmpty ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
tableEmpty: aString
	self propertyAt: #tableEmpty put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
tableSummary
	^ self propertyAt: #tableSummary ifAbsentPut: [ self defaultTableSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 10:16'!
tableSummary: aString
	self propertyAt: #tableSummary put: aString.! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 4/24/2005 10:16'!
visible
	^ self showBatch
		ifFalse: [ self cache ]
		ifTrue: [
			self cache
				copyFrom: self batchStartIndex
				to: self batchEndIndex ].! !

!MANumberDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MATextInputComponent.! !

!MATextDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MATextAreaComponent.! !

!WACounter class methodsFor: '*Magritte-Seaside-description' stamp: 'lr 4/24/2005 10:14'!
descriptionCount
	^ (MANumberDescription selector: #count label: 'Count' priority: 200)
		condition: [ :value | value isInteger ];
		beRequired;
		yourself.! !

!MATableDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MATableComponent.! !

!MAReportContainer class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MAReportComponent.! !

!MAPasswordDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MATextPasswordComponent.! !

!MASingleSelectionDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 4/24/2005 10:17'!
defaultComponentClasses
	^ Array with: MASelectListComponent with: MARadioGroupComponent.! !
